
# Sendftp v1.0 (4/6/97)	by Ernst <baschneo@trick.informatik.uni-stuttgart.de>
# =============================================================================

# This is a proc to send a file via FTP to another server. Useful in many
# situations, for example to upload a HTML file generated by eggdrop to your
# www server if it is not the same as your eggdrops machine.

# Change this to something to use to check if a host is alife.
# set pingcheck "" to disable this checking.
# /bin/ping -c 1 works on Linux machine. Set to "" to disable this checking
set pingcheck "/bin/ping -c 1"

# Call it with all parameters given.  'localfile' and 'remotefile' *must* both
# be given as FULL paths to the filenames, the first on the local, the second
# on the remote	server.  For example:

# sendftp /home/bill/stats.htm www.gov.org bill secret /home/bgates/public_html/stats.htm

proc sendftp { localfile server user pass remotefile } {
	global pingcheck
	if {![file exist $localfile]} {
		return "sendftp: File $localfile does not exist."
	}
	if {$pingcheck != ""} {
		if {[catch {exec [lindex $pingcheck 0] [lrange $pingcheck 1 end] $server > /dev/null 2> /dev/null}]} {
			return "sendftp: Machine $server does not seem to be alife."
		}
	}
	set noftp [catch {set ftpprog [exec which ftd]}] 
	if {$noftp} {
		if {[file executable /usr/bin/ftp]} {
			set ftpprog /usr/bin/ftp
			set noftp 0
		}
		if {[file executable /bin/ftp]} {
			set ftpprog /usr/bin/ftp
			set noftp 0
		}
	}
	if {$noftp} {
		return "sendftp: You don't seem to have the 'ftp' tool"
	}
	set pipe [open "|$ftpprog -n $server" w]
	puts $pipe "user $user $pass"
	puts $pipe "bin"
	puts $pipe "put $localfile $remotefile"
	puts $pipe "quit"
	close $pipe
	return 1
}
